import { Http,Util } from '@/utils';
import EntityService from '../entity-service';



/**
 * 职务教育服务对象基类
 *
 * @export
 * @class HRDutyEduServiceBase
 * @extends {EntityServie}
 */
export default class HRDutyEduServiceBase extends EntityService {

    /**
     * Creates an instance of  HRDutyEduServiceBase.
     * 
     * @param {*} [opts={}]
     * @memberof  HRDutyEduServiceBase
     */
    constructor(opts: any = {}) {
        super(opts);
    }

    /**
     * 初始化基础数据
     *
     * @memberof HRDutyEduServiceBase
     */
    public initBasicData(){
        this.APPLYDEKEY ='hrdutyedu';
        this.APPDEKEY = 'hrdutyeduid';
        this.APPDENAME = 'hrdutyedus';
        this.APPDETEXT = 'hrdutyeduname';
        this.APPNAME = 'pim';
        this.SYSTEMNAME = 'ibizhumanresources';
    }

// 实体接口

    /**
     * Select接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyEduServiceBase
     */
    public async Select(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && context.hrdutyedu){
            let res:any = Http.getInstance().get(`/hrduties/${context.hrduty}/hrdutyedus/${context.hrdutyedu}/select`,isloading);
            
            return res;
        }
            let res:any = Http.getInstance().get(`/hrdutyedus/${context.hrdutyedu}/select`,isloading);
            
            return res;
    }

    /**
     * Create接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyEduServiceBase
     */
    public async Create(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && true){
            let masterData:any = {};
            Object.assign(data,masterData);
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            let tempContext:any = JSON.parse(JSON.stringify(context));
            let res:any = await Http.getInstance().post(`/hrduties/${context.hrduty}/hrdutyedus`,data,isloading);
            
            return res;
        }
        let masterData:any = {};
        Object.assign(data,masterData);
        if(!data.srffrontuf || data.srffrontuf !== "1"){
            data[this.APPDEKEY] = null;
        }
        if(data.srffrontuf){
            delete data.srffrontuf;
        }
        let tempContext:any = JSON.parse(JSON.stringify(context));
        let res:any = await Http.getInstance().post(`/hrdutyedus`,data,isloading);
        
        return res;
    }

    /**
     * Update接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyEduServiceBase
     */
    public async Update(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && context.hrdutyedu){
            let masterData:any = {};
            Object.assign(data,masterData);
            let res:any = await Http.getInstance().put(`/hrduties/${context.hrduty}/hrdutyedus/${context.hrdutyedu}`,data,isloading);
            
            return res;
        }
        let masterData:any = {};
        Object.assign(data,masterData);
            let res:any = await  Http.getInstance().put(`/hrdutyedus/${context.hrdutyedu}`,data,isloading);
            
            return res;
    }

    /**
     * Remove接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyEduServiceBase
     */
    public async Remove(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && context.hrdutyedu){
            let res:any = Http.getInstance().delete(`/hrduties/${context.hrduty}/hrdutyedus/${context.hrdutyedu}`,isloading);
            return res;
        }
            let res:any = Http.getInstance().delete(`/hrdutyedus/${context.hrdutyedu}`,isloading);
            return res;
    }

    /**
     * Get接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyEduServiceBase
     */
    public async Get(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && context.hrdutyedu){
            let res:any = await Http.getInstance().get(`/hrduties/${context.hrduty}/hrdutyedus/${context.hrdutyedu}`,isloading);
            
            return res;
        }
            let res:any = await Http.getInstance().get(`/hrdutyedus/${context.hrdutyedu}`,isloading);
            
            return res;
    }

    /**
     * GetDraft接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyEduServiceBase
     */
    public async GetDraft(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && true){
            let res:any = await Http.getInstance().get(`/hrduties/${context.hrduty}/hrdutyedus/getdraft`,isloading);
            res.data.hrdutyedu = data.hrdutyedu;
            
            return res;
        }
        let res:any = await  Http.getInstance().get(`/hrdutyedus/getdraft`,isloading);
        res.data.hrdutyedu = data.hrdutyedu;
        
        return res;
    }

    /**
     * CheckKey接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyEduServiceBase
     */
    public async CheckKey(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && context.hrdutyedu){
            let masterData:any = {};
            Object.assign(data,masterData);
            let res:any = await Http.getInstance().post(`/hrduties/${context.hrduty}/hrdutyedus/${context.hrdutyedu}/checkkey`,data,isloading);
            
            return res;
        }
            let res:any = Http.getInstance().post(`/hrdutyedus/${context.hrdutyedu}/checkkey`,data,isloading);
            return res;
    }

    /**
     * Save接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyEduServiceBase
     */
    public async Save(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && context.hrdutyedu){
            let masterData:any = {};
            Object.assign(data,masterData);
            let res:any = await Http.getInstance().post(`/hrduties/${context.hrduty}/hrdutyedus/${context.hrdutyedu}/save`,data,isloading);
            
            return res;
        }
        let masterData:any = {};
        Object.assign(data,masterData);
            let res:any = await  Http.getInstance().post(`/hrdutyedus/${context.hrdutyedu}/save`,data,isloading);
            
            return res;
    }

    /**
     * FetchDefault接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyEduServiceBase
     */
    public async FetchDefault(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            let res:any = Http.getInstance().get(`/hrduties/${context.hrduty}/hrdutyedus/fetchdefault`,tempData,isloading);
            return res;
        }
        let tempData:any = JSON.parse(JSON.stringify(data));
        let res:any = Http.getInstance().get(`/hrdutyedus/fetchdefault`,tempData,isloading);
        return res;
    }
}